//Menu adapted and modified from Simple Custom Menu by Felix44

--MENU FLAGS
rawset(_G, "MNF_SLIDER", 1)
rawset(_G, "MNF_NOSAVE", 2)
rawset(_G, "MNF_SHOWVALUE", 4)
rawset(_G, "MNF_CHANGEPAGE", 8)

addHook("PlayerSpawn", function(player)
	player.menu = {}
	player.menu.pointer = 1
	player.menu.pagepointer = 1
	player.menu.pagename = "Page 1"
	player.menu.show = false
	player.menu.timer = 0
	player.menu.contents = {
		[1] = {
			{value = 1, name = "Charge Meter", description = "Enable/Disable Charge Meter", options = {"DISABLED", "ENABLED"}},
			{value = 0, name = "Charge Colour", description = "Set the fill colour of the Charge Meter", maxvalue = 8, options = {"DEFAULT", "BLUE", "ORANGE", "RED", "PINK", "PURPLE", "YELLOW", "GREEN"}, toggledby = 1},
			{value = 0, name = "Effect Colour", description = "Set the colour of certain visual effects", maxvalue = 4, options = {"YELLOW", "ORANGE", "RED", "LIGHT BLUE"}},
			{value = 1, name = "Combo Counter", description = "Enable/Disable Combo Counter", options = {"DISABLED", "ENABLED"}},
			{value = 1, name = "Swap Jump/Stomp", description = "Swap the inputs for Charge Jump and Charge Stomp", options = {"ON", "OFF"}},
			{value = 0, name = "Super Button", description = "Set the button to go Super with", maxvalue = 4, options = {"CUSTOM1", "CUSTOM2", "CUSTOM3", "TOSSFLAG"}}
		}
	}
	io.openlocal("client/JetMetal.dat", "a+"):close()
	local file = io.openlocal("client/JetMetal.dat", "r+")
	for e = 1,#player.menu.contents
		for i = 1,#player.menu.contents[e]
			if not player.menu.contents[e][i].flags then player.menu.contents[e][i].flags = 0 end
			if not player.menu.contents[e][i].selectedvflags then player.menu.contents[e][i].selectedvflags = V_YELLOWMAP end
			if not player.menu.contents[e][i].pagename then player.menu.contents[e][i].pagename = "Page "..player.menu.contents[e][i].value end
			if player.menu.contents[e][i].func then continue end
			if not player.menu.contents[e][i].maxvalue
					player.menu.contents[e][i].maxvalue = 2
			elseif player.menu.contents[e][i].maxvalue == 1
				CONS_Printf(player, "\133ERROR IN PAGE "..e.."\nSetting "..i.."'s maxvalue is 1! Are you sure it's intentional?")
				player.menu.contents[e][i].maxvalue = 2
				CONS_Printf(player, "\133Maxvalue was set to 2.")
			elseif player.menu.contents[e][i].maxvalue < 1
				CONS_Printf(player, "\133ERROR IN PAGE "..e.."\nSetting "..i.."'s maxvalue("..player.menu.contents[e][i].maxvalue..") is too small! Are you sure it's intentional?")
				player.menu.contents[e][i].maxvalue = 2
				CONS_Printf(player, "\133Maxvalue was set to 2.")
			end
			if not player.menu.contents[e][i].options
				player.menu.contents[e][i].options = {"OFF", "ON"}
			elseif #player.menu.contents[e][i].options < player.menu.contents[e][i].maxvalue and not (player.menu.contents[e][i].slider or player.menu.contents[e][i].flags & MNF_SLIDER)
				CONS_Printf(player, "\133ERROR IN PAGE "..e.."\nSetting "..i.."'s options can't be fewer than maxvalue("..player.menu.contents[e][i].maxvalue..")!")
				for a =1,player.menu.contents[e][i].maxvalue
					if player.menu.contents[e][i].options[a] then continue end
					player.menu.contents[e][i].options[a] = "Missing!"
				end
			end
			if player.menu.contents[e][i].flags & MNF_NOSAVE then continue end
			local text = file:read("*l")
			if text
				player.menu.contents[e][i].value = tonumber(text)	
			end
		end
	end
end)

/*
player.menu.contents is the main part of the menu, every key in this table will refer to a page, if you only want a single page make a single key [1],
	you can put the elements of the menu pages inside these keys, you can have as many elements as you want, but it might be best not to have more than 10 for each page
	"value" sets their value, starting from 0, set this value to the setting's default value
		use this for your checks in your Lua, an example is at the end of this Lua
	"name" is the name of the setting that will appear on the menu
	"description" is the small text that will appear on the bottom of the screen
	"toggledby" is an extra parameter for subsections, set it to the number of the setting which your subsection setting should be depending on
		do note that if the setting that controls the subsecton is off, it will make the subsection not modifiable, but it will NOT set it to false automatically, remember that when making the checks in your other Luas
	"func" is an extra parameter for function setting, these settings can't be toggled on/off, selecting them will call the given function instead
	"maxvalue" is for a setting with more than 2 options, set this parameter to the amount of options your setting can be
		do note that "value" starts from 0, so if for example you want a 3 option setting "value" will start from 0 and reach it's max at 2 (maxvalue would still have to be set to 3 though)
		if this parameter is omitted it will be set to 2 (equivalent to an ON/OFF setting)
	"options" must be a table containing the names of all the possible setting's options, this table should be as long as maxvalue (example: if maxvalue is 3 the table should contain 3 strings)
		if this parameter is omitted it will be set to {"OFF", "ON"}
	"slider" is a boolean parameter that when set to true it displays a slider instead of a string, thus "options" can be omitted
		this parameter is deprecated since MNF_SLIDER now exists, but it can still be used and it will work the same way
	"flags" is the parameter for menu flags (MNF_*), you can see them and what they do near the start of the file
	"vflags" is the parameter for video flags (V_*), you could use this for example to give the text a different color when not selected,
		this parameter accepts any video flags, but it's primarely meant for color flags (V_*MAP) and it might break with other video flags
	"selectedvflags" is a parameter that gives the specified video flags (V_*) when the setting is selected, this default to V_YELLOWMAP if omitted
		this parameter accepts any video flags, but it's primarely meant for color flags (V_*MAP) and it might break with other video flags
	"pagename" is a parameter that sets the name of the page, this defaults to "Page " + the "value" parameter if omitted
		this paramter will only work with MNF_CHANGEPAGE settings
*/

addHook("PreThinkFrame", function()
	for player in players.iterate
		local menu = player.menu
		local contents = menu.contents[player.menu.pagepointer]
		menu.timer = max($-1, 0)
		if menu.show == false or menu.timer then return end
		local cmd = player.cmd
		if cmd.forwardmove > 0
			menu.pointer = max($-1, 1)
			menu.timer = 5
			S_StartSound(player.mo, sfx_menu1, player)
		elseif cmd.forwardmove < 0
			menu.pointer = min($+1, #contents)
			menu.timer = 5
			S_StartSound(player.mo, sfx_menu1, player)
		end
		if cmd.buttons & BT_JUMP
			if contents[menu.pointer].toggledby and contents[contents[menu.pointer].toggledby].value == 0 then return end
			if contents[menu.pointer].func
				contents[menu.pointer].func()
			elseif contents[menu.pointer].flags & MNF_CHANGEPAGE
				menu.pagename = contents[menu.pointer].pagename
				menu.pagepointer = contents[menu.pointer].value
				menu.pointer = 1
			else
				contents[menu.pointer].value = ($+1)%contents[menu.pointer].maxvalue
			end
			menu.timer = 5
			S_StartSound(player.mo, sfx_menu1, player)
		end
		if cmd.buttons & BT_SPIN
			if contents[menu.pointer].toggledby and contents[contents[menu.pointer].toggledby].value == 0 then return end
			contents[menu.pointer].value = $-1
			if contents[menu.pointer].value < 0
				contents[menu.pointer].value = contents[menu.pointer].maxvalue-1
			end
			menu.timer = 5
			S_StartSound(player.mo, sfx_menu1, player)
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.menu.show
		player.powers[pw_nocontrol] = 1
		player.powers[pw_flashing] = 1
		player.mo.momx = 0
		player.mo.momy = 0
		player.mo.momz = 0
	end
end)

COM_AddCommand("jetmetalmenu", function(player)
	if not (player.mo and player.mo.valid)
		CONS_Printf(player, "You must be in a level to use this.")
		return
	end
	player.menu.show = not $
	if player.menu.show == false
		local file = io.openlocal("client/JetMetal.dat", "w")
		for e = 1,#player.menu.contents
			for i = 1,#player.menu.contents[e]
				if player.menu.contents[e][i].func or player.menu.contents[e][i].flags & MNF_NOSAVE then continue end
				file:write(player.menu.contents[e][i].value.."\n")
			end
		end
		file:close()
	end
end, COM_LOCAL)

hud.add(function(v,player)
	if not player.menu.show then return end
	v.drawFill(60, 25, 200, 25+(10*#player.menu.contents[player.menu.pagepointer]), 31)
	v.drawString(160, 30, "Jet Metal Sonic Settings", V_ALLOWLOWERCASE, "center")
	local pagename = player.menu.pagename
	if #player.menu.contents == 1 then pagename = "" end
	v.drawString(257, 45+(10*#player.menu.contents[player.menu.pagepointer]), pagename, 0, "small-right")
	for i = 1,#player.menu.contents[player.menu.pagepointer]
		local thecolor = player.menu.contents[player.menu.pagepointer][i].vflags or 0
		local thex = 0
		if player.menu.pointer == i then thecolor = player.menu.contents[player.menu.pagepointer][i].selectedvflags end
		if player.menu.contents[player.menu.pagepointer][i].toggledby
			thex = 10
			if player.menu.contents[player.menu.pagepointer][player.menu.contents[player.menu.pagepointer][i].toggledby].value == 0
				thecolor = $|V_TRANSLUCENT
			end
		end
		local thename = "Missing name!"
		if player.menu.contents[player.menu.pagepointer][i].name and player.menu.contents[player.menu.pagepointer][i].name ~= ""
			thename = player.menu.contents[player.menu.pagepointer][i].name	
		end
		v.drawString(65+thex, 35+(10*i), thename, thecolor|V_ALLOWLOWERCASE)
		if not (player.menu.contents[player.menu.pagepointer][i].slider or player.menu.contents[player.menu.pagepointer][i].flags & MNF_SLIDER)
			local thevalue = player.menu.contents[player.menu.pagepointer][i].func and "" or player.menu.contents[player.menu.pagepointer][i].options[player.menu.contents[player.menu.pagepointer][i].value+1]
			if player.menu.contents[player.menu.pagepointer][i].flags & MNF_CHANGEPAGE then thevalue = "" end
			if player.menu.contents[player.menu.pagepointer][i].flags & MNF_SHOWVALUE then thevalue = player.menu.contents[player.menu.pagepointer][i].options[player.menu.contents[player.menu.pagepointer][i].value+1] end
			v.drawString(255, 35+(10*i), thevalue, thecolor, "right")
		elseif not player.menu.contents[player.menu.pagepointer][i].func
			local patchs = v.cachePatch("M_SLIDEL")
			local patchm = v.cachePatch("M_SLIDEM")
			local patche = v.cachePatch("M_SLIDER")
			local patchc = v.cachePatch("M_SLIDEC")
			v.draw(213, 35+(10*i), patchs)
			for e = 1,8
				v.draw(215+(4*e), 35+(10*i), patchm)
			end
			v.draw(249, 35+(10*i), patche)
			local value = player.menu.contents[player.menu.pagepointer][i].value
			local maxvalue = player.menu.contents[player.menu.pagepointer][i].maxvalue-1
			v.drawScaled(FRACUNIT*215 + 36*FixedDiv(value, maxvalue), FRACUNIT*35 + (10*i)*FRACUNIT, FRACUNIT, patchc)
		end
	end
	local patch = v.cachePatch("M_CURSOR")
	v.draw(45, 35+(10*player.menu.pointer), patch)
	local desctext = "No description found!"
	if player.menu.contents[player.menu.pagepointer][player.menu.pointer].description and player.menu.contents[player.menu.pagepointer][player.menu.pointer].description ~= ""
		desctext = player.menu.contents[player.menu.pagepointer][player.menu.pointer].description
	end
	v.drawString(60, 160, desctext, V_ALLOWLOWERCASE, "thin")
end)